[inherit('vglobal')]
module MathTTT(output);

procedure RowAppend (Var globalRowStart: PCoeffRow; RowBeginPtr: PVector);
var
  lastRow,TempPtr    : PCoeffRow;
begin
  New(TempPtr);
  TempPtr^.RowStart:=RowBeginPtr;
  TempPtr^.upRow:=nil;
  TempPtr^.downRow:=nil;
  matrixSize:=matrixSize+1;
  {/// if the list is empty, make the new record the only one \\\}
  if globalRowStart = nil then globalRowStart:=TempPtr
  else begin
    TempPtr^.downRow:=globalRowStart;
    globalRowStart^.upRow:=TempPtr;
    globalRowStart := TempPtr;
  end;
end; {/// Proc. RowAppend ///}

procedure NewRowAppend (Var globalRowStart: PCoeffRow; RowBeginPtr: PVector);
var
  endRow,TempPtr    : PCoeffRow;
begin
  New(TempPtr);
  TempPtr^.RowStart:=RowBeginPtr;
  TempPtr^.upRow:=nil;
  TempPtr^.downRow:=nil;
  matrixSize:=matrixSize+1;
  {/// if the list is empty, make the new record the only one \\\}
  if globalRowStart=nil then globalRowStart:=TempPtr
  else begin
    {/// search for last row in current matrix structure ///}
    endRow:=globalRowStart;
    while endRow^.downRow<>nil do endRow:=endRow^.downRow;
    endRow^.downRow:=TempPtr;
    TempPtr^.upRow:=endRow;
  end;
end; {/// Proc. RowAppend ///}

procedure EntryAppend (Var oneRowStart: PVector; newEntry: double);
var
  endCol,TempPtr: PVector;
begin
  {/// Create a new record and place the information in it \\\}
  New(TempPtr);
  {GetMem(TempPtr,sizeOf(TVector));}
  TempPtr^.realNum:=newEntry;
  TempPtr^.nextNum:=nil;

  {/// if the list is empty, make the new record the only one \\\}
  if oneRowStart=nil then oneRowStart:=TempPtr
  else begin
    TempPtr^.nextNum:=oneRowStart;
    oneRowStart:=TempPtr;
  end;
end; {/// Proc. EntryAppend ///}

procedure NewEntryAppend (Var oneRowStart: PVector; newEntry: double);
var
  endCol,TempPtr: PVector;
begin
  {/// Create a new record and place the information in it \\\}
  New(TempPtr);
  {GetMem(TempPtr,sizeOf(TVector));}
  TempPtr^.realNum:=newEntry;
  TempPtr^.nextNum:=nil;

  {/// if the list is empty, make the new record the only one \\\}
  if oneRowStart=nil then oneRowStart:=TempPtr
  else begin
    endCol:=oneRowStart;
    while endCol^.nextNum<>nil do endCol:=endCol^.nextNum;
    endCol^.nextNum:=TempPtr;
  end;
end; {/// Proc. EntryAppend ///}

procedure formDynaMatx(var inMatx:PcoeffRow; numRow,numCol:integer);
var
  iRow,jCol: integer;
  thisRowStart: PVector;
begin
  if inMatx<>nil then freeMatrixMemory(inMatx);
  for iRow:=1 to numRow do begin
    thisRowStart:=nil;
    for jCol:=1 to numCol do
     NewEntryAppend(thisRowStart,iRow*100+jCol);
    NewRowAppend(inMatx,thisRowStart);
  end;
end;

procedure formDynaVector(var inVector:PVector; length:integer);
var
  i: integer;
begin
  if inVector<>nil then freeVectorMemory(inVector);
  for i:=1 to length do NewEntryAppend(inVector,i);
end;

function getEntryDynaMatx(inMatx:PcoeffRow;iRow,jCol:integer):double;
var
  curRow,curCol: integer;
  curCoefRow   : PcoeffRow;
  curEntry     : PVector;
begin
  curCoefRow:=inMatx;
  for curRow:=2 to iRow do if curCoefRow<>nil then
   curCoefRow:=curCoefRow^.downRow;
  if curCoefRow<>nil then begin
    curEntry:=curCoefRow^.RowStart;
    for curCol:=2 to jCol do if curEntry<>nil then
     curEntry:=curEntry^.nextNum;
  end;
  if curEntry<>nil then getEntryDynaMatx:=curEntry^.RealNum;
end;

Procedure putEntryDynaMatx(inMatx:PcoeffRow;iRow,jCol:integer;inValue:double);
var
  curRow,curCol: integer;
  curCoefRow   : PcoeffRow;
  curEntry     : PVector;
begin
  curCoefRow:=inMatx;
  for curRow:=2 to iRow do if curCoefRow<>nil then
   curCoefRow:=curCoefRow^.downRow;
  if curCoefRow<>nil then begin
    curEntry:=curCoefRow^.RowStart;
    for curCol:=2 to jCol do if curEntry<>nil then
     curEntry:=curEntry^.nextNum;
   end;
  if curEntry<>nil then curEntry^.RealNum:=inValue;
end;

[global]
procedure copyMatx(souMatx:PcoeffRow;var tarMatx:PcoeffRow);
{called from xsample.p}
var
  aCoeffRow : PcoeffRow;
  aEntry,tarRowStart : PVector;
begin
  if tarMatx<>nil then freeMatrixMemory(tarMatx);
  aCoeffRow:=souMatx;               { assign pointer to start of matrix }
  while aCoeffRow<>nil do begin
   tarRowStart:=nil;
   aEntry:=aCoeffRow^.RowStart;  { point to first entry of each row }
   while aEntry<>nil do begin
    EntryAppend(tarRowStart,aEntry^.RealNum);
    aEntry:=aEntry^.nextNum;
   end;
   newRowAppend(tarMatx,tarRowStart);
   aCoeffRow:=aCoeffRow^.downRow;
  end;
end;

function GetDeterminant(matx: PCoeffRow; fRow,fCol,subSize: integer):double;
var
  ltRow,ltCol,coli,j,cnt  : integer;
  negSum,posSum,a         : double;

  procedure moveRightCol(var col: integer);
  begin
    {inc(col);}
    col:=col+1;
    if col>ltCol then col:=col-subSize;
  end;

  procedure moveLeftCol(var col: integer);
  begin
    {dec(col);}
    col:=col-1;
    if col<fCol then col:=col+subSize;
  end;

begin
  ltRow:=fRow+subSize-1;
  ltCol:=fCol+subSize-1;
  if subSize>2 then begin
    posSum:=0.0;
    for cnt:=fCol to ltCol do begin
       coli:=cnt;
       a:=1.0;
       for j:=fRow to ltRow do begin
          a:=a*getEntryDynaMatx(matx,j,coli);
          moveRightCol(coli);
        end;
       posSum:=posSum+a;
     end;

    negSum:=0.0;
    for cnt:=ltCol downto fCol do begin
       coli:=cnt;
       a:=1.0;
       for j:=fRow to ltRow do begin
          a:=a*getEntryDynaMatx(matx,j,coli);
          moveLeftCol(coli);
        end;
       negSum:=negSum+a;
     end;
    GetDeterminant:=posSum-negSum;
   end
  else if subSize=2 then begin
     GetDeterminant:=
     getEntryDynaMatx(matx,fRow,fCol)*getEntryDynaMatx(matx,ltRow,ltCol)-
     getEntryDynaMatx(matx,ltRow,fCol)*getEntryDynaMatx(matx,fRow,ltCol);
   end
   else if subSize=1 then GetDeterminant:=getEntryDynaMatx(matx,fRow,fCol);
end;

procedure backDiagonal(inMatx: PcoeffRow; bdyTag, ColTag: integer);
var
  i,j,IsMax,index,numRow,numCol : integer;
  dump,sum,tempMax : double;
begin
  numCol:=bodyAry[ColTag]^.mSeg;
  numRow:=bodyAry[bdyTag]^.mSeg;
  with inMatx^ do
  for i:=1 to numCol do begin
    sum:=0.0;
    {\\\ search for maximum in column \\\}
    if (bdyTag<>ColTag) then begin
      IsMax:=0;
      tempMax:=0.0;
      for index:=1 to numRow do begin
        dump:=getEntryDynaMatx(inMatx,index,i);
        if abs(dump)>tempMax then begin
          tempMax:=abs(dump);
          IsMax:=index;
         end;
       end;
     end
    else IsMax:=numRow+1-i;
    {\\\ adjustment of maximum value \\\}
    for j:=1 to numRow do if j<>(IsMax) then
      sum:=sum + getEntryDynaMatx(inMatx,j,i)*bodyAry[bdyTag]^.seg[j]^.ds;
    dump:=-sum/bodyAry[bdyTag]^.seg[IsMax]^.ds;
    putEntryDynaMatx(inMatx,IsMax,i,dump);
   end;{with/for}
end;

procedure ZeroCircCorr(inMatx:PCoeffRow;bdyTag,ColTag:integer);
var
  i,j,IsMax,index,numRow,numCol : integer;
  sum,theBase,dump : double;
  dmpAry,tmpValue : vectorM;
begin
  numCol:=bodyAry[ColTag]^.mSeg;
  numRow:=bodyAry[bdyTag]^.mSeg;
  with inMatx^ do
  for i:=1 to numCol do begin
    {fillChar(tmpValue,sizeOf(VectorM),0);
    fillChar(dmpAry,sizeOf(VectorM),0);}
    sum:=0.0;
    for j:=1 to numRow do begin
      dmpAry[j]:=getEntryDynaMatx(inMatx,j,i)*bodyAry[bdyTag]^.seg[j]^.ds;
      sum:=sum+dmpAry[j];
      if dmpAry[j]<>0.0 then tmpValue[j]:=exp(1.0*ln(abs(dmpAry[j])))
      else tmpValue[j]:=0.0;
     end;
    if bdyTag<>ColTag then begin
      theBase:=0.0;
      for j:=1 to numRow do theBase:=theBase+tmpValue[j];
      for j:=1 to numRow do begin
        dump:= getEntryDynaMatx(inMatx,j,i)-sum*tmpValue[j]
               /(theBase*bodyAry[bdyTag]^.seg[j]^.ds);
        putEntryDynaMatx(inMatx,j,i,dump);
       end;
     end
    else begin
      theBase:=0.0;
      for j:=1 to numRow do if (j<>i) then
         theBase:=theBase+tmpValue[j];
      for j:=1 to numRow do if (j<>i) then begin
        dump:=getEntryDynaMatx(inMatx,j,i) -
              sum*tmpValue[j]/(theBase*bodyAry[bdyTag]^.seg[j]^.ds);
        putEntryDynaMatx(inMatx,j,i,dump);
       end;
     end;
   end;{with/for}
end;

  (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
    getMatrices calculates the self-interact, and mutual-interact coupling
    coefficient matrices for all active bluff bodies.

    matrices are processed also for zero-circulation correction, and
    vorticity conservation equation.  Return matrices are ready to use, and
    form the global matrix.

   \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*)

procedure GetMatrices;
var
  dumpValue,xApart,yApart,
  FbCos,FbSin,FbDs,FbXpvt,FbYpvt,rSq,u,v   : double;
  i,j,FbmSeg,FixBody,MoveBody,AryI    : integer;


(*         ----> col

         T             :             :               T
   row   |             :             :               |
      I  |    C11      :     C12     :      C1n      |
      V  |             :             :               |
         |             :             :               |
         |_____________:_____________:_______________|
         |             :             :               |
         |             :             :               |
         |    C21      :     C22     :      C2n      |
         |             :             :               |
         |_____________:_____________:_______________|
         |             :             :               |
         |             :             :               |
         |    Cn1      :             :               |
         |                           :               |
         L                           :

    Notation:

    coup[row,col], i.e. coup[j,i] denotes the effect of seg[i] on seg[j];
*)

begin
  (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
     calculate leading diagonal sub-matrices for multiple bodies config.
     For single body calc. only one matrix required
   \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*)

  for FixBody:=1 to numActiveBbody do with bodyAry[FixBody]^ do begin
    {/// form dynamic matrix to store entry values ///}
    formDynaMatx(selfMatx,mSeg,mSeg);
    {/// calculate entry values ///}
    for i:=1 to mSeg do               {/// keep col ///}
     for j:=1 to mSeg do
      if j<>i then begin {/// move down by row ///}
        xApart:=(seg[i]^.pvt.Re-seg[j]^.pvt.Re);
        yApart:=(seg[i]^.pvt.Im-seg[j]^.pvt.Im);
        rSq:=2.0*(sqr(xApart)+sqr(yApart));
        u:=yApart/(pi*rSq);
        v:=-xApart/(pi*rSq);

        {cpCoeff^.coup[i,j]:=(u*seg[i]^.cosine+v*seg[i]^.sine)*seg[j]^.ds;}
        dumpValue:=(u*seg[i]^.cosine+v*seg[i]^.sine)*seg[j]^.ds;
        putEntryDynaMatx(selfmatx,i,j,dumpValue);
       end
      else begin{/// calculate self-induce coupling coefficient ///}
        dumpValue:=-0.5-getCofSlope(FixBody,i)/(8.0*pi);
        putEntryDynaMatx(selfmatx,i,j,dumpValue);
       { self-coupling coeff for seg[i], this is used to calculate induced
         velocity on the outwards surface of the vortex sheet; therefore
         0.5 is added to account for the velocity jump across sheet at
         outside surface.  This value is used in procedure Bodyxyuv }
        seg[i]^.selfCoup:=1.0+dumpValue;
       end;

    {///  correct coupling matrix for zero internal circulation ///}
    ZeroCircCorr(selfMatx,FixBody,FixBody);
  end;{for/with fixBody}

  (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
     Add seg[j]^.ds the leading diagonal matrices to account for
     prescribed circulation.  Same procedure applied to both single
     body and multiple bodies configurations.
   \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*)

  for FixBody:=1 to numActiveBbody do with bodyAry[FixBody]^ do begin
    for j:=1 to mSeg do begin
      FbDs:=bodyAry[FixBody]^.seg[j]^.ds;
      for i:=1 to mSeg do begin
        dumpValue:=getEntryDynaMatx(selfMatx,i,j)+FbDs;
        putEntryDynaMatx(selfMatx,i,j,dumpValue);
       end;
     end;
  end;

  (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
     For multiple bodies configuration, evaluate mutual-bodies interaction
     coupling coefficient
   \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*)
  if numActiveBbody > 1 then begin
    FixBody:=1;
    while FixBody<numActiveBbody do begin
      MoveBody:=FixBody+1;
      AryI:=FixBody;
      FbmSeg:=bodyAry[FixBody]^.mSeg;
      while MoveBody<=numActiveBbody do with bodyAry[MoveBody]^ do begin
        formDynaMatx(mutlMatx[FixBody],mSeg,FbmSeg);
        formDynaMatx(bodyAry[FixBody]^.mutlMatx[AryI],FbmSeg,mSeg);

        for j:=1 to FbmSeg do begin { by Row }
          FbCos:=bodyAry[FixBody]^.seg[j]^.cosine;
          FbSin:=bodyAry[FixBody]^.seg[j]^.sine;
          FbDs:=bodyAry[FixBody]^.seg[j]^.ds;
          FbXpvt:=bodyAry[FixBody]^.seg[j]^.pvt.Re;
          FbYpvt:=bodyAry[FixBody]^.seg[j]^.pvt.Im;
          for i:=1 to mSeg do begin { by Column }
            xApart:=(seg[i]^.pvt.Re - FbXpvt);
            yApart:=(seg[i]^.pvt.Im - FbYpvt);
            rSq:=sqr(xApart)+sqr(yApart);
            u:=0.5*yApart/(pi*rSq);
            v:=-0.5*xApart/(pi*rSq);

            dumpValue:=(u*seg[i]^.cosine+v*seg[i]^.sine)*FbDs;
            putEntryDynaMatx(mutlMatx[FixBody],i,j,dumpValue);

            dumpValue:=-(u*FbCos+v*FbSin)*seg[i]^.ds;
            putEntryDynaMatx(bodyAry[FixBody]^.MutlMatx[AryI],j,i,dumpValue);

          end;{/ for i, complete one col in sub. matx; one row in compli matx /}
        end;{/ for j complete whole matrices /}

        {/// adjust subject matrix ///}
        ZeroCircCorr(mutlMatx[FixBody],MoveBody,FixBody);
        {/// adjust complimentary matrix ///}
        ZeroCircCorr(bodyAry[FixBody]^.mutlMatx[AryI],FixBody,MoveBody);

        {/// increase index, and move on to next body ///}
        {inc(AryI);
        inc(MoveBody);}
        AryI:=AryI+1;
        MoveBody:=MoveBody+1;

      end;{/// while/with  MoveBody ///}
      {inc(FixBody);}
      FixBody:=FixBody+1;
    end;{/// while FixBody ///}
  end;{if}
end; {proc getMatrices}

  (*///////////////////////////////////////////////////////////////////////
    procedure getCoupling

    evaluates 'basic' coupling coeff matx, and

    modifies the coupling coeff for vorticity conservation equation,
    i.e. segment length is added to each coupling coefficient.
    The same procedure applied to multiple-body matrix.
  ////////////////////////////////////////////////////////////////////////*)

procedure GetCoupling;
var
  RowBdy,ColBdy,AryI,i,j : integer;
  thisRowStart           : PVector;
begin
  GetMatrices;  { get the matrices of self-interact, and mutual interact }
  (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
     Form global matrix, start off from the last row of last column in
     order to match with the pointer allocation procedure.
     Upon completion, the pointer coupCoeffMatx points to the first row of
     first column of the global matrix.
   \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*)

  matrixSize:=0;
  for RowBdy:=1 to numActiveBbody do with bodyAry[RowBdy]^ do begin
   for i:=1 to bodyAry[RowBdy]^.mSeg do begin {row : start from the last row}
     {/// start off a new row, set temporary pointer nil ///}
     thisRowStart:=nil;
     AryI:=1;

     for ColBdy:=1 to numActiveBbody do begin
       if RowBdy<>ColBdy then begin
         for j:=1 to bodyAry[ColBdy]^.mSeg do {col}
          NewEntryAppend(thisRowStart,getEntryDynaMatx(mutlMatx[AryI],i,j));
         {inc(AryI);}
         AryI:=AryI+1;
        end
       else
        for j:=1 to bodyAry[RowBdy]^.mSeg do {col}
         NewEntryAppend(thisRowStart,getEntryDynaMatx(selfMatx,i,j));
      end; {for ColBdy}
     {/// one global Row complete, append to global matrix ///}
     NewRowAppend(dynaMatx,thisRowStart);
    end;{/// for i, all rows of RowBdy finish ///}
   end;

  {if saveData then saveCoupling('newglob.txt');}

  {/// release memory from heap ///}
  for j:=1 to numActiveBbody do with bodyAry[j]^ do begin
     if selfMatx<>nil then freeMatrixMemory(selfMatx);
     for i:=1 to maxMutual do if mutlMatx[i]<>nil then
      freeMatrixMemory(mutlMatx[i]);
    end;
end;{proc getCoupling}

procedure invertMatrix (theMatrix: PcoeffRow);

type
  PPivot = ^TPivot;  {/// used in matrix inversion ///}
  TPivot = record
   PvtValue : double;
   nextPvt: PPivot;
  end;

var
  tmpR,a,b,transf            : double;
  tmpPivot,pivot             : PPivot;
  activeRow,i,j,k,matxSize   : integer;
  activeCoefRow, curCoefRow  : PcoeffRow;
  curEntry,ActiveEntry       : PVector;

function getEntry(row, col: integer): double;
var
  iRow,jCol: integer;
  RowPtr: PcoeffRow;
  ColPtr: PVector;
begin
  if Row<activeRow then
   while Row<>ActiveRow do begin
      {dec(ActiveRow);}
      ActiveRow:=ActiveRow-1;
      activeCoefRow:=activeCoefRow^.upRow;
    end
   else if Row>activeRow then
    while Row<>ActiveRow do begin
      {inc(ActiveRow);}
      ActiveRow:=ActiveRow+1;
      activeCoefRow:=activeCoefRow^.downRow;
     end;
  RowPtr:=activeCoefRow;
  jCol:=1;ColPtr:=RowPtr^.RowStart;
  while jCol<col do begin
    ColPtr:=ColPtr^.nextNum;
    {inc(jCol);}
    jCol:=jCol+1;
  end;
  getEntry:=ColPtr^.RealNum;
  ActiveEntry:=ColPtr;
end; {getEntry}

{Procedure PutEntry(valueAsgn: double);
begin
  ActiveEntry^.RealNum:=ValueAsgn;
end;}

begin  {invertMatrix}
  activeRow:=1;
  activeCoefRow:=theMatrix;
  pivot:=nil;
  matxSize:=matrixSize;
  for i:=1 to matxSize do begin
     {/// create pivot pointer ///}
     New(tmpPivot);
     tmpPivot^.pvtValue:=0.0;
     tmpPivot^.nextPvt:=nil;
     if Pivot = nil then
       Pivot:= tmpPivot
     else begin
       tmpPivot^.nextPvt:= Pivot;
       Pivot:= tmpPivot;
     end;
   end;

  for i:=1 to matxSize do begin
    a:=getEntry(i,i); {putEntry(1.0);}
    ActiveEntry^.RealNum:=1.0;
    tmpPivot:=pivot;
    for j:=1 to matxSize do begin
      tmpPivot^.pvtValue:=getEntry(j,i)/a;
      ActiveEntry^.RealNum:=tmpPivot^.pvtValue;
      tmpPivot:=tmpPivot^.nextPvt;
     end;
    for j:=1 to matxSize do
     if i<>j then begin
        b:=getEntry(i,j);
        ActiveEntry^.RealNum:=0.0;
        tmpPivot:=pivot;
        for k:=1 to matxSize do begin
          transf:=getEntry(k,j)-b*tmpPivot^.pvtValue;
          ActiveEntry^.RealNum:=transf;
          tmpPivot:=tmpPivot^.nextPvt;
         end;
      end;
   end;
   tmpPivot:=pivot;
   while tmpPivot<>nil do begin
     pivot:=tmpPivot^.nextPvt;
     dispose(tmpPivot);
     tmpPivot:=pivot;
    end;
   {if saveData then saveCoupling('Newvted');}
end;  {invertMatrix}

  {////////////////////////////////////////////////////////////////////////
    procedure solution

    evaluates the coupling coefficient matrix and performs matrix
    invertion, and eventually solves for surface vorticity.

    Note : The coupling coeff. has to be evaluated everytime this procedure
           is called. On completion of this procedure the coupling coeff.
           matrix is inverted.

           fullRHS vector has to be evaluated before calling this procedure.

   ////////////////////////////////////////////////////////////////////////}

procedure PublishSoln;
var
  bdy : integer;
  totalSumCirc:double;
begin
  totalSumCirc:=0.0;
  for bdy:=1 to numActiveBbody do totalSumCirc:=thisTotal[bdy]+totalSumCirc;
  totalSumCirc:=totalSumCirc + sumActiveDv + totalBoundCirc + snuff;
  write(' ',TotalSumCirc:5:3);
end;

procedure saveSolution;
var
  bdy,j   : integer;
  outFile : text;
  strSave,saveName    : Tstring;
begin
  saveName:='survor.txt';
  rewrite(outFile,saveName);
  for bdy:=1 to numActiveBbody do with BodyAry[bdy]^ do begin
     writeln(outFile,'Body : ',bdy);
     for j:=1 to mSeg do
       writeln(outFile,survor[j]:16:10,seg[j]^.ds:16:10);
   end;
  close(outFile);
end;

[global]
procedure solution;
var
  i,j,bdy: integer;
  a: double;
  curCoeffRow: PcoeffRow;
  curEntry,curRhs: PVector;
begin
  if firstAccess then begin {// evaluate coupling coeff matrix for first access //}
    GetCoupling;
    invertMatrix(dynaMatx);
    firstAccess:=false;
   end;

  {fillChar(thisTotal,sizeOf(thisTotal),0);}
  for bdy:=1 to maxBody do thisTotal[bdy]:=0.0;

  bdy:=1;j:=1;
  curCoeffRow:=dynaMatx;               { assign pointer to start of matrix }
  while curCoeffRow<>nil do begin
     curEntry:=curCoeffRow^.RowStart;  { point to first entry of each row }
     curRhs:=globalRhs;
     a:=0.0;
     while curEntry<>nil do begin
         a:=a+curEntry^.RealNum * curRhs^.RealNum;
         curRhs:=curRhs^.NextNum;
         curEntry:=curEntry^.nextNum;
     end;
     bodyAry[bdy]^.survor[j]:=a;
     thisTotal[bdy]:=thisTotal[bdy]+a*bodyAry[bdy]^.seg[j]^.ds;
     j:=j+1;
     if j>bodyAry[bdy]^.mSeg then begin
        bdy:=bdy+1;
        j:=1;
     end;
     curCoeffRow:=curCoeffRow^.downRow;
   end;
  {solnValid:=true;}
  if Publish then PublishSoln;
  if calculateMode=calPotential then saveSolution;
end;

[global]
procedure EnforceKuttaCondition;
var
  bdy,i,j: integer;
  dump,deter,Aprod: double;
  tmpColumn,
  CircColumn,
  gammaColumn  : array[1..maxBody] of double;
  {tempMatrix   : smallMatrix;}
  tempMatrix   : PCoeffRow;
  tmpVector    : PVector;
begin
  for j:=1 to numActiveBbody do with bodyAry[j]^ do begin
    if bodyAry[j]^.aerofoil then
     gammaColumn[j]:=-(bodyAry[j]^.survor[segTe]+bodyAry[j]^.survor[segTe+1])
    else gammaColumn[j]:=0.0;
   end; {for/with}
  tempMatrix:=nil;
  formDynaMatx(tempMatrix,numActiveBbody,numActiveBbody);

  for bdy:=1 to numActiveBbody do begin
     tmpVector:=globalRhs;
     for j:=1 to numActiveBbody do begin
       if j=bdy then bodyAry[j]^.prescribeCirc:=1.0
        else bodyAry[j]^.prescribeCirc:=0.0;
       for i:=1 to bodyAry[j]^.mSeg do begin
         bodyAry[j]^.FullRhs[i]:=bodyAry[j]^.prescribeCirc;
         tmpVector^.realNum:=bodyAry[j]^.FullRhs[i];
         tmpVector:=tmpVector^.nextNum;
        end;
      end;
     solution;

     for j:=1 to numActiveBbody do with bodyAry[j]^ do begin
       if aerofoil then begin
         dump:=(survor[segTe]+survor[segTe+1]);
         putEntryDynaMatx(tempMatrix,j,bdy,dump);
        end
       else
        if j=bdy then putEntryDynaMatx(tempMatrix,j,bdy,1.0)
          else putEntryDynaMatx(tempMatrix,j,bdy,0.0);
      end;
   end;

  deter:=GetDeterminant(tempMatrix,1,1,numActiveBbody);
  for bdy:=1 to numActiveBbody do with bodyAry[bdy]^ do begin
    if aerofoil then begin
      for i:=1 to numActiveBbody do begin
        tmpColumn[i]:=getEntryDynaMatx(tempMatrix,i,bdy);
        PutEntryDynaMatx(tempMatrix,i,bdy,gammaColumn[i]);
       end;
      prescribeCirc:=GetDeterminant(tempMatrix,1,1,numActivebbody)/deter;
      {for i:=1 to numActiveBbody do tempMatrix[i,bdy]:=tmpColumn[i];}
      for i:=1 to numActiveBbody do
       putEntryDynaMatx(tempMatrix,i,bdy,tmpColumn[i]);
     end
    else prescribeCirc:=0.0;
   end;
  freeMatrixMemory(tempMatrix);
end;

End.


